package cn.efunbox.audio.aop;

import cn.efunbox.audio.entity.res.ResUserEvent;
import cn.efunbox.audio.service.res.ResUserEventService;
import cn.efunbox.audio.utils.SnowflakeIdUtil;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.servlet.HandlerInterceptor;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class ResLogInterceptor implements HandlerInterceptor {

    @Autowired
    ResUserEventService resUserEventService;

    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
        //System.out.println(request.getServletPath());
        //System.out.println(request.getHeader("USERID"));
        //记入日志
        String userId = request.getHeader("USERID");
        if(StringUtils.isNotBlank(userId)) {
            ResUserEvent resUserEvent = new ResUserEvent();
            resUserEvent.setId(SnowflakeIdUtil.getSnowflakeIdUtil().nextId());
            resUserEvent.setInterfaceName(request.getServletPath());
            resUserEvent.setUserId(userId);
            resUserEventService.recordLog(resUserEvent);
        }
        return true;
    }

    @Override
    public void postHandle(HttpServletRequest request, HttpServletResponse response, Object handler, ModelAndView modelAndView) throws Exception {

    }

    @Override
    public void afterCompletion(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex) throws Exception {

    }
}
