package cn.efunbox.audio.entity;

import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.math.BigInteger;
import java.sql.Timestamp;

/**
 * Album
 * Created by xusq on 2018/5/8.
 */
@Data
@ToString
@Entity
@Table(name = "album")
@DynamicInsert
@DynamicUpdate
public class Album implements Serializable {

    @Id
    private BigInteger id;

    private String name;

    private String image;

    private String language;

    private String age;

    /**
     * 适用人群
     */
    @Column(name = "suitable_crowd")
    private String suitableCrowd;

    private String version;


    /**
     * 科目
     */
    private String subject;

    /**
     * 册数
     */
    private String volume;

    @Column(name = "media_type")
    private Integer mediaType;

    @Column(name = "product_package")
    private String productPackage;

    private Timestamp created;

    private Timestamp modified;
}
