package cn.efunbox.audio.entity.hag;

import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.io.Serializable;
import java.util.Date;

/**
 * HagProduct
 * Created by xusq on 2019/12/25.
 */

@Data
@ToString
@Entity
@Table(name = "hag_product")
@DynamicInsert
@DynamicUpdate
public class HagProduct implements Serializable {

    @Id
    private String id;

    @Column(name = "ability_id")
    private String abilityId;

    @Column(name = "sku_name")
    private String skuName;

    private String description;

    @Column(name = "sku_type")
    private String skuType;

    @Column(name = "right_controller")
    private String rightController;

    @Column(name = "price_controller")
    private String priceController;

    @Column(name = "sku_release_state")
    private String skuReleaseState;

    @Column(name = "price_group_description")
    private String priceGroupDescription;

    private String promotion;

    private String currency;

    @Column(name = "original_amount")
    private String originalAmount;

    private String amount;

    @Column(name = "begin_time")
    private String beginTime;

    @Column(name = "end_time")
    private String endTime;

    @Column(name = "resource_type")
    private String resourceType;

    @Column(name = "album_id")
    private String albumId;

    @Column(name = "gmt_created")
    private Date gmtCreated;

    @Column(name = "gmt_modified")
    private Date gmtModified;

}
