package cn.efunbox.audio.impl;

import cn.efunbox.audio.entity.Audio;
import cn.efunbox.audio.entity.Grouping;
import cn.efunbox.audio.entity.Record;
import cn.efunbox.audio.repository.AudioRepo;
import cn.efunbox.audio.repository.RecordRepo;
import cn.efunbox.audio.service.AudioService;
import cn.efunbox.audio.service.RecordService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by yao on 17-9-26.
 */
@Service
public class RecordServiceImpl implements RecordService {

    @Autowired
    RecordRepo recordRepo;

    @Override
    public Page<Record> SearchAll(int page, int size){
        if(size<=0)
            size = 50;
        Pageable pageable = new PageRequest(page, size);
        Page<Record> list = recordRepo.findAll(pageable);
        return list;
    }

    @Override
    public List<Record> SearchById(Long id){
        List<Record> list = recordRepo.findById(id);
        return list;
    }

    @Override
    public Page<Record> SearchByIdChannel(Long id, int page, int size){
        if(size<=0)
            size = 50;
        Pageable pageable = new PageRequest(page, size);
        Page<Record> list = recordRepo.findByIdChannel(id, pageable);
        return list;
    }

    @Override
    public Page<Record> SearchByIdDevice(Long id, int page, int size){
        if(size<=0)
            size = 50;
        Pageable pageable = new PageRequest(page, size);
        Page<Record> list = recordRepo.findByIdDevice(id, pageable);
        return list;
    }

    @Override
    public Page<Record> SearchByIdAudio(Long id, int page, int size){
        if(size<=0)
            size = 50;
        Pageable pageable = new PageRequest(page, size);
        Page<Record> list = recordRepo.findByIdAudio(id, pageable);
        return list;
    }

    @Override
    public Page<Record> SearchCreatedBetween(int page, int size, Timestamp start, Timestamp end){
        if(size<=0)
            size = 50;
        Pageable pageable = new PageRequest(page, size);
        Page<Record> list = recordRepo.findByCreatedBetween(start, end, pageable);
        return list;
    }

    @Override
    public Page<Record> SearchByIdChannelAndCreatedBetween(Long id, int page, int size, Timestamp start, Timestamp end){
        if(size<=0)
            size = 50;
        Pageable pageable = new PageRequest(page, size);
        Page<Record> list = recordRepo.findByIdChannelAndCreatedBetween(id, start, end, pageable);
        return list;
    }

    @Override
    public Page<Record> SearchByIdDeviceAndCreatedBetween(Long id, int page, int size, Timestamp start, Timestamp end){
        if(size<=0)
            size = 50;
        Pageable pageable = new PageRequest(page, size);
        Page<Record> list = recordRepo.findByIdDeviceAndCreatedBetween(id, start, end, pageable);
        return list;
    }

    @Override
    public Page<Record> SearchByIdAudioAndCreatedBetween(Long id, int page, int size, Timestamp start, Timestamp end){
        if(size<=0)
            size = 50;
        Pageable pageable = new PageRequest(page, size);
        Page<Record> list = recordRepo.findByIdAudioAndCreatedBetween(id, start, end, pageable);
        return list;
    }

    @Override
    public Record Insert(Record r){
        r = recordRepo.save(r);
        return r;
    }

    @Override
    public void Delete(Long id){
        recordRepo.delete(id);
    }

}
