package cn.efunbox.audio.impl;

import cn.efunbox.audio.service.StatisticsService;
import org.hibernate.SQLQuery;
import org.hibernate.transform.Transformers;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.persistence.EntityManager;
import javax.persistence.Query;
import java.util.List;
import java.util.Map;

/**
 * StatisticsServiceImpl
 * Created by xusq on 2018/7/10.
 */
@Service
public class StatisticsServiceImpl implements StatisticsService {

    @Autowired
    private EntityManager entityManager;

    @Override
    public List<Map<String, Object>> registerCount(String beginDate, String endDate) {

        Query query = entityManager.createNativeQuery("SELECT c.`name` AS channel,DATE(d.created) AS date,COUNT(1) AS count FROM `device` d,channel c" +
                " WHERE d.`id_channel` = c.`id` AND d.created BETWEEN '" + beginDate + "' AND '" + endDate + "'" +
                " GROUP BY d.id_channel,date" +
                " ORDER BY d.id_channel,date");
        query.unwrap(SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        return query.getResultList();
    }

    @Override
    public List<Map<String, Object>> viewCount(String beginDate, String endDate) {

        Query query = entityManager.createNativeQuery("SELECT c.`name` AS channel,DATE(r.created) AS date,COUNT(1) AS count FROM `record` r,channel c" +
                " WHERE r.`id_channel` = c.`id` AND r.created BETWEEN '" + beginDate + "' AND '" + endDate + "'" +
                " GROUP BY r.id_channel,date" +
                " ORDER BY r.id_channel,date");
        query.unwrap(SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        return query.getResultList();
    }

    @Override
    public List<Map<String, Object>> resourcesCount(String beginDate, String endDate) {

        Query query = entityManager.createNativeQuery("SELECT c.`name` AS channel,DATE(r.created) AS date,a.name AS audio,COUNT(1) AS count FROM `record` r,channel c,audio a" +
                " WHERE r.`id_channel` = c.`id` AND r.id_audio = a.id AND r.created BETWEEN '" + beginDate + "' AND '" + endDate + "'" +
                " GROUP BY r.id_channel,date,r.id_audio" +
                " ORDER BY r.id_channel,date");
        query.unwrap(SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        return query.getResultList();
    }
}
