package cn.efunbox.audio.repository;

import cn.efunbox.audio.entity.Audio;
import cn.efunbox.audio.repository.base.ProjectJpaRepository;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.math.BigInteger;
import java.util.List;

/**
 * Created by yao on 17-9-26.
 */
@Repository
public interface AudioRepo extends ProjectJpaRepository<Audio, Long> {

    Audio findById(Long id);

    Page<Audio> findAll(Pageable pageable);

    Page<Audio> findByMediaType(Integer mediaType, Pageable pageable);

    List<Audio> findByName(String name);

    List<Audio> findByMediaTypeAndName(Integer mediaType, String name);

//    @Query("from Audio a where a.name LIKE CONCAT('%',:name,'%')")
//    @Query(value = "select * From audio a where a.name like '%?1%'", nativeQuery = true)
//    List<Audio> findByNameLike(String name);

//    @Query("from Audio a where a.media_type=:mediaType and a.name LIKE :name")
//    List<Audio> findByMediaTypeAndNameLike(Integer mediaType, String name);


    Page<Audio> findByIdGroup(Long idGroup, Pageable pageable);

    Page<Audio> findByMediaTypeAndIdGroup(Integer mediaType, Long idGroup, Pageable pageable);


//    @Query("from Audio a where a.name like CONCAT('%',:name,'%') and a.album like CONCAT('%',:album,'%') ")
//    List<Audio> searchByNameAndAlbum(@Param("name") String name, @Param("album") String album);

    List<Audio> findByMediaTypeAndAlbumIdIn(int mediaType, List<BigInteger> albumIds);

    @Query("from Audio a where a.albumId in :albumIds")
    List<Audio> findByAlbumIdIn(@Param("albumIds") List<BigInteger> albumIds);

    List<Audio> findByMediaTypeAndNameAndAlbumIdIn(int mediaType, String name, List<BigInteger> albumIds);

    List<Audio> findByNameAndAlbumIdIn(String name, List<BigInteger> albumIds);

    @Query("from Audio a where a.name like CONCAT('%',:name,'%') and a.albumId in :albumIds")
    List<Audio> findByNameLikeAndAlbumIdIn(@Param("name") String name, @Param("albumIds") List<BigInteger> albumIds);

    @Query("from Audio a where a.name LIKE CONCAT('%',:name,'%')")
    List<Audio> findByNameLike(@Param("name") String name);
}
