package cn.efunbox.audio.service;

import cn.efunbox.audio.utils.ApiResult;
import cn.efunbox.audio.vo.SearchVO;
import cn.efunbox.audio.entity.Audio;
import cn.efunbox.audio.page.OnePage;
import org.springframework.data.domain.Page;

import java.util.List;

/**
 * Created by yao on 17-9-26.
 */
public interface AudioService {

    public Audio GetOne(Long id);

    public Page<Audio> SearchAll(int mediaType, int page, int size);

    public Page<Audio> SearchByIdGroup(int mediaType, Long idGroup, int page, int size);

    public List<Audio> SearchByName(int mediaType, String name);

    public List<Audio> SearchByAlbum(int mediaType, String album);

    public List<Audio> SearchByNameAlbum(int mediaType, String name, String album);

    public Audio Insert(Audio audio);

    public void Delete(Long id);

    OnePage<Audio> pageList(Audio audio, Integer pageNo, Integer pageSize);

    OnePage<Audio> searchList(SearchVO searchVO);

    Audio getAudioInfo(Long id);

    ApiResult countTime();

}
