package cn.efunbox.audio.utils;

import java.io.Serializable;
import java.util.Map;


public class ResApiResult<T> implements Serializable {
    private static final long serialVersionUID = 1L;
    private int recode;
    private String msg;
    private T data;

    public ResApiResult(ResApiCode ResApiCode) {
        this(ResApiCode.getCode(), ResApiCode.getMessage());
    }

    private ResApiResult(int recode, String msg) {
        this.recode = recode;
        this.msg = msg;
    }

    private ResApiResult(ResApiCode ResApiCode, String msg) {
        this.recode = ResApiCode.getCode();
        this.msg = msg;
    }

    private ResApiResult(ResApiCode ResApiCode, T data) {
        this(ResApiCode.getCode(), ResApiCode.getMessage());
        this.data = data;
    }

    public static ResApiResult ok() {
        return new ResApiResult(ResApiCode.OK);
    }

    public static ResApiResult ok(Object value) {
        return new ResApiResult(ResApiCode.OK, value);
    }

//    public static ApiResult ok(String name, Object value) {
//        return new ApiResult(ResApiCode.OK, Maper.of(name, value));
//    }

    public static ResApiResult ok(Map<String, Object> data) {
        return new ResApiResult(ResApiCode.OK, data);
    }

//    public static ApiResult error(ApiException exception) {
//        return new ApiResult(Integer.parseInt(exception.getCode()), exception.getMessage());
//    }

    public static ResApiResult error(ResApiCode code) {
        return new ResApiResult(code);
    }

    public static ResApiResult error(ResApiCode code,String msg){
        return new ResApiResult(code,msg);
    }

    public static ResApiResult error(ResApiCode code, Object value) {
        return new ResApiResult(code, value);
    }

//    public static ApiResult error(ResApiCode code, String name, Object value) {
//        return new ApiResult(code, Maper.of(name, value));
//    }

    public static ResApiResult error(ResApiCode code, Map<String, Object> data) {
        return new ResApiResult(code, data);
    }

    public int getRecode() {
        return recode;
    }

    public void setRecode(int recode) {
        this.recode = recode;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }

    public T getData() {
        return this.data;
    }

    public void setData(T data) {
        this.data = data;
    }
}
