package cn.efunbox.audio.vo.hag;

import cn.efunbox.audio.entity.hag.HagAlbum;

import java.util.Objects;

/**
 * AlbumConverter
 * Created by xusq on 2019/12/26.
 */
public class AlbumConverter {

    private AlbumConverter(){}

    public static ContentVO albumToContentVO(HagAlbum album){

        if (Objects.isNull(album)) {
            return null;
        }

        ContentVO contentVO = new ContentVO();

        contentVO.setType("ALBUM");
        ContentVO.Payload payload = new ContentVO.Payload();
        payload.setAlbumCode(album.getId());
        payload.setAlbumName(album.getAlbumName());
        payload.setArtistNames(album.getArtistName());
        payload.setChapter(album.getChapter());
        payload.setChargeType(album.getChargeType());
        payload.setRelateCpSkuId(album.getRelateCpSkuId());
        payload.setCrowd(album.getCrowd());
        payload.setFirstClass(album.getFirstClass());
        payload.setSecondClass(album.getSecondClass());
        payload.setThirdClass(album.getThirdClass());
        payload.setSongNum(album.getSongNum());
        payload.setStatus(album.getStatus());

        ContentVO.Payload.AlbumIconVO albumIconVO = new ContentVO.Payload.AlbumIconVO();

        ContentVO.Payload.AlbumIconVO.AlbumIconImageVO largeImageVO = new ContentVO.Payload.AlbumIconVO.AlbumIconImageVO();
        largeImageVO.setHeightPixels(album.getHeightPixels());
        largeImageVO.setWidthPixels(album.getWidthPixels());
        largeImageVO.setUrl(album.getLargeIcon());
        albumIconVO.setLarge(largeImageVO);

        ContentVO.Payload.AlbumIconVO.AlbumIconImageVO mediumImageVO = new ContentVO.Payload.AlbumIconVO.AlbumIconImageVO();
        mediumImageVO.setHeightPixels(album.getHeightPixels());
        mediumImageVO.setWidthPixels(album.getWidthPixels());
        mediumImageVO.setUrl(album.getMediumIcon());
        albumIconVO.setMedium(mediumImageVO);

        ContentVO.Payload.AlbumIconVO.AlbumIconImageVO smallImageVO = new ContentVO.Payload.AlbumIconVO.AlbumIconImageVO();
        smallImageVO.setHeightPixels(album.getHeightPixels());
        smallImageVO.setWidthPixels(album.getWidthPixels());
        smallImageVO.setUrl(album.getSmallIcon());
        albumIconVO.setSmall(smallImageVO);

        payload.setIcon(albumIconVO);

        contentVO.setPayload(payload);

        return contentVO;
    }
}
