package cn.efunbox.audio.vo.hag;

import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * HagSkillReq
 * Created by xusq on 2019/12/25.
 */
@Data
public class HagSkillReq implements Serializable {

    private String version;
    private HagSession session;
    private Endpoint endpoint;
    private HagHeader header;
    private HagInquire inquire;

    @Data
    public static final class HagSession {
        private Boolean isNew;
        private String sessionId;
    }

    @Data
    public static final class HagHeader {
        private String type;
        private String timestamp;
    }

    @Data
    public static final class Endpoint {
        private Auth auth;
        private Device device;
        private String locale;

        @Data
        public static final class Auth {

            private Application application;
            @Data
            public static final class Application {
                private String appId;
            }
        }
        @Data
        public static final class Device {
            private String deviceId;
        }

    }

    @Data
    public static final class HagInquire {

        private OrderRight orderRight;
        private String inquireId;
        private Intent intent;

        @Data
        public static final class OrderRight {

            private String skuId;

            private String amount;

            private String currency;

            private String orderId;

            private String boughtTime;

            private List<ResourceRight> resourceRights;


            @Data
            public static final class ResourceRight {

                private String resourceType;
                private String resourceId;
            }
        }

        @Data
        public static final class Intent {

            private String apiKey;

            private Slots slots;

            @Data
            public static final class Slots {
                private ContentCode albumCode;
                private ContentCode contentCode;
                @Data
                public static final class ContentCode {
                    private String name;
                    private List<Value> values;

                    @Data
                    public static final class Value {
                        private String real;
                    }
                }

            }
        }

    }


}
