package cn.efunbox.audio.vo.hag;

import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * ProductVO
 * Created by xusq on 2019/12/25.
 */
@Data
public class ProductVO implements Serializable {

    private SkuInfo skuInfo;

    private List<Price> prices;

    private List<ResourceRight> resourceRights;

    private String updateTime;

    @Data
    public static final class SkuInfo {

        private String abilityId;
        private String cpSkuId;
        private String skuName;
        private String description;
        private String skuType;
        private String rightController;
        private String priceController;
        private String skuReleaseState;

    }

    @Data
    public static final class Price {

        private String priceGroupDescription;
        private String promotion;
        private String currency;
        private List<PriceItem> pricesItems;
        private TimeFilter timeFilter;

        @Data
        public static final class PriceItem  {

            private String originalAmount;
            private String amount;
        }

        @Data
        public static final class TimeFilter {

            private String beginTime;
            private String endTime;
        }
    }

    @Data
    public static final class ResourceRight  {

        private String resourceType;
        private String resourceId;
    }
}
